Eshop/WebbApp/Controllers/HomeController.cs
using FrameworkCore.Domains.Store.Usecases.Product;
using FrameworkCore.Domains.Store.Usecases.Product.Models;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using System.Diagnostics;
using WebbApp.Models;


namespace WebbApp.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;
        private IProductUsecase _productUsecase;

        public HomeController(
            ILogger<HomeController> logger,
            IProductUsecase productUsecase
        )
        {
            _logger = logger;
            _productUsecase = productUsecase;
        }

        public async Task<IActionResult> Index()
        {
            //var paginationReq = new ProductPaginationModel()
            //{
            //    CurrentPage = 1,
            //    SearchKeyword = "boba"
            //};
            //var res = await _productUsecase.GetProductPagination(paginationReq);
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

Eshop/WebbApp/ViewComponents/ShowListProductViewComponent.cs
using FrameworkCore.Domains.Store.Usecases.Product;
using FrameworkCore.Domains.Store.Usecases.Product.Models;
using FrameworkCore.Domains.Store.Usecases.Store;
using FrameworkCore.Domains.User.Entities;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;

namespace WebbApp.ViewComponents;

//[ViewComponent("ShowListProduct")]
public class ShowListProductViewComponent : ViewComponent
{

    private IStoreUsecase _storeUsecase;
    private IProductUsecase _productUsecase;
    public ShowListProductViewComponent(IStoreUsecase storeUsecase, IProductUsecase productUsecase)
    {
        _storeUsecase = storeUsecase;
        _productUsecase = productUsecase;
    }
    public async Task<IViewComponentResult> InvokeAsync(string searchKeyword = "", int currentPage = 1)
    {

        var paginationReq = new ProductPaginationModel()
        {
            CurrentPage = currentPage,
            SearchKeyword = searchKeyword
        };
        var res = await _productUsecase.GetProductPagination(paginationReq);
        return await Task.FromResult((IViewComponentResult)View("~/Views/Product/_ListProduct.cshtml", res.Data!.ListProduct));
    }
}

Eshop/WebbApp/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<!-- Topbar Search -->
@inject Microsoft.AspNetCore.Antiforgery.IAntiforgery Xsrf
@Html.AntiForgeryToken()
<div class="d-none d-sm-inline-block form-inline mr-auto ml-md-3 my-2 my-md-0 mw-100 navbar-search">
    <div class="input-group">
        <input type="text" id="searchKeyword" class="form-control bg-light border-0 small" placeholder="Search for..." aria-label="Search" aria-describedby="basic-addon2">
        <div class="input-group-append">
            <button onclick="getProducts()" id="searchBtn" class="btn btn-primary" type="button">
                <i class="fas fa-search fa-sm" ></i>
            </button>
        </div>
    </div>
</div>

<div id="listProductContainer" class="row justify-content-around">
    @await Component.InvokeAsync("ShowListProduct", new {searchKey = "", currentPage = 1})    
</div>

@section script{
    <script src="~/js/view/cart/AddCartItem.js"> </script>
    <script type="text/javascript">
        var currentPostPage = 2;
        $(document).ready(function () {
            console.log("search")
            $(window).scroll(function() {
                if($(window).scrollTop() + $(window).height() >= $(document).height()) {
                    getProducts();
                    currentPostPage++;
                }
            });
        });



        function getProducts(){ 
            const searchKey = $('#searchKeyword')[0].value;
            var token = $('input[name="__RequestVerificationToken"]').val();
            const url = `${window.location.origin}/Product/ShowListProductView?searchKeyword=${searchKey}&currentPage=${currentPostPage}`;
            $.ajax({
               url: url,
               type: "post",
               dataType: "json",
               data: {
                    __RequestVerificationToken: token
                },
               complete: function (result) {
                   $("#listProductContainer").html($("#listProductContainer").html()+result.responseText);
               }
           });
        }
    
 </script>

}